## olsrd 0.6.1

=== Makefile ===
# The olsr.org Optimized Link-State Routing daemon(olsrd)
# Copyright (c) 2004, Andreas Tonnesen(andreto@olsr.org)
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# * Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright 
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its 
#   contributors may be used to endorse or promote products derived 
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

# Please also write a new version to:
# gui/win32/Main/Frontend.rc (line 71, around "CAPTION [...]")
# gui/win32/Inst/installer.nsi (line 57, around "MessageBox MB_YESNO [...]")
VERS =		0.6.1

TOPDIR = .
include Makefile.inc

# pass generated variables to save time
MAKECMD = $(MAKE) OS="$(OS)" WARNINGS="$(WARNINGS)"

LIBS +=		$(OS_LIB_DYNLOAD)

ifeq ($(OS), win32)
LDFLAGS +=	-Wl,--out-implib=libolsrd.a
LDFLAGS +=	-Wl,--export-all-symbols
endif

SWITCHDIR =	src/olsr_switch
CFGDIR =	src/cfgparser
include $(CFGDIR)/local.mk
TAG_SRCS =	$(SRCS) $(HDRS) $(wildcard $(CFGDIR)/*.[ch] $(SWITCHDIR)/*.[ch])

.PHONY: default_target switch
default_target: $(EXENAME)

$(EXENAME):	$(OBJS) src/builddata.o
		$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

cfgparser:	$(CFGDEPS) src/builddata.o
		$(MAKE) -C $(CFGDIR)

switch:		
	$(MAKECMD) -C $(SWITCHDIR)

# generate it always
.PHONY: src/builddata.c
src/builddata.c:
	@$(RM) "$@"
	@echo "#include \"defs.h\"" >> "$@" 
	@echo "const char olsrd_version[] = \"olsr.org -  $(VERS)-git_`git log -1 --pretty=%h`-hash_`./make/hash_source.sh`\";"  >> "$@"
	@date +"const char build_date[] = \"%Y-%m-%d %H:%M:%S\";" >> "$@" 
	@echo "const char build_host[] = \"$(shell hostname)\";" >> "$@" 


.PHONY: help libs clean_libs libs_clean clean uberclean install_libs libs_install install_bin install_olsrd install build_all install_all clean_all 

clean:
	-rm -f $(OBJS) $(SRCS:%.c=%.d) $(EXENAME) $(EXENAME).exe src/builddata.c $(TMPFILES)
	-rm -f libolsrd.a
	-rm -f olsr_switch.exe
	-rm -f gui/win32/Main/olsrd_cfgparser.lib
	-rm -f olsr-setup.exe
	-rm -fr gui/win32/Main/Release
	-rm -fr gui/win32/Shim/Release

uberclean:	clean clean_libs
	-rm -f $(TAGFILE)
#	BSD-xargs has no "--no-run-if-empty" aka "-r"
	find . \( -name '*.[od]' -o -name '*~' \) -not -path "*/.hg*" -print0 | xargs -0 rm -f
	$(MAKECMD) -C $(SWITCHDIR) clean
	$(MAKECMD) -C $(CFGDIR) clean

install: install_olsrd

install_bin:
		mkdir -p $(SBINDIR)
		install -m 755 $(EXENAME) $(SBINDIR)
		$(STRIP) $(SBINDIR)/$(EXENAME)

install_olsrd:	install_bin
		@echo ========= C O N F I G U R A T I O N - F I L E ============
		@echo $(EXENAME) uses the configfile $(CFGFILE)
		@echo a default configfile. A sample RFC-compliance aimed
		@echo configfile can be found in olsrd.conf.default.rfc.
		@echo However none of the larger OLSRD using networks use that
		@echo so install a configfile with activated link quality exstensions
		@echo per default.
		@echo can be found at files/olsrd.conf.default.lq
		@echo ==========================================================
		mkdir -p $(ETCDIR)
		-cp -i files/olsrd.conf.default.lq $(CFGFILE)
		@echo -------------------------------------------
		@echo Edit $(CFGFILE) before running olsrd!!
		@echo -------------------------------------------
		@echo Installing manpages $(EXENAME)\(8\) and $(CFGNAME)\(5\)
ifneq ($(MANDIR),)
		mkdir -p $(MANDIR)/man8/
		cp files/olsrd.8.gz $(MANDIR)/man8/$(EXENAME).8.gz
		mkdir -p $(MANDIR)/man5/
		cp files/olsrd.conf.5.gz $(MANDIR)/man5/$(CFGNAME).5.gz
endif

tags:
		$(TAGCMD) -o $(TAGFILE) $(TAG_SRCS)

rpm:
		@$(RM) olsrd-current.tar.bz2
		@echo "Creating olsrd-current.tar.bz2 ..."
		@./list-excludes.sh | tar  --exclude-from=- --exclude="olsrd-current.tar.bz2" -C .. -cjf olsrd-current.tar.bz2 olsrd-current
		@echo "Building RPMs..."
		@rpmbuild -ta olsrd-current.tar.bz2
#
# PLUGINS
#

# This is quite ugly but at least it works
ifeq ($(OS),linux)
SUBDIRS = $(notdir $(shell find lib -maxdepth 2 -name Makefile -not -path lib/Makefile -printf "%h\n"|sort))
else
ifeq ($(OS),win32)
SUBDIRS := dot_draw httpinfo mini pgraph secure txtinfo
else
ifeq ($(OS),android)
SUBDIRS := arprefresh bmf dot_draw dyn_gw_plain httpinfo mini nameservice pgraph secure tas txtinfo watchdog
else
SUBDIRS := dot_draw dyn_gw dyn_gw_plain httpinfo mini nameservice pgraph secure txtinfo watchdog
endif
endif
endif

libs:
		set -e;for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR);done

libs_clean clean_libs:
		-for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR) clean;rm -f lib/$$dir/*.so lib/$$dir/*.dll;done

libs_install install_libs:
		set -e;for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR) install;done

httpinfo:
		$(MAKECMD) -C lib/httpinfo clean
		$(MAKECMD) -C lib/httpinfo 
		$(MAKECMD) -C lib/httpinfo DESTDIR=$(DESTDIR) install 

tas:
		$(MAKECMD) -C lib/tas clean
		$(MAKECMD) -C lib/tas
		$(MAKECMD) -C lib/tas DESTDIR=$(DESTDIR) install

dot_draw:
		$(MAKECMD) -C lib/dot_draw clean
		$(MAKECMD) -C lib/dot_draw
		$(MAKECMD) -C lib/dot_draw DESTDIR=$(DESTDIR) install

nameservice:
		$(MAKECMD) -C lib/nameservice clean
		$(MAKECMD) -C lib/nameservice
		$(MAKECMD) -C lib/nameservice DESTDIR=$(DESTDIR) install

dyn_gw:
		$(MAKECMD) -C lib/dyn_gw clean
		$(MAKECMD) -C lib/dyn_gw
		$(MAKECMD) -C lib/dyn_gw DESTDIR=$(DESTDIR) install

dyn_gw_plain:
		$(MAKECMD) -C lib/dyn_gw_plain clean
		$(MAKECMD) -C lib/dyn_gw_plain
		$(MAKECMD) -C lib/dyn_gw_plain DESTDIR=$(DESTDIR) install

secure:
		$(MAKECMD) -C lib/secure clean
		$(MAKECMD) -C lib/secure
		$(MAKECMD) -C lib/secure DESTDIR=$(DESTDIR) install

pgraph:
		$(MAKECMD) -C lib/pgraph clean
		$(MAKECMD) -C lib/pgraph 
		$(MAKECMD) -C lib/pgraph DESTDIR=$(DESTDIR) install 

bmf:
		$(MAKECMD) -C lib/bmf clean
		$(MAKECMD) -C lib/bmf 
		$(MAKECMD) -C lib/bmf DESTDIR=$(DESTDIR) install 

quagga:
		$(MAKECMD) -C lib/quagga clean
		$(MAKECMD) -C lib/quagga 
		$(MAKECMD) -C lib/quagga DESTDIR=$(DESTDIR) install 

mdns:
		$(MAKECMD) -C lib/mdns clean
		$(MAKECMD) -C lib/mdns 
		$(MAKECMD) -C lib/mdns DESTDIR=$(DESTDIR) install 
txtinfo:
		$(MAKECMD) -C lib/txtinfo clean
		$(MAKECMD) -C lib/txtinfo 
		$(MAKECMD) -C lib/txtinfo DESTDIR=$(DESTDIR) install 

arprefresh:
		$(MAKECMD) -C lib/arprefresh clean
		$(MAKECMD) -C lib/arprefresh
		$(MAKECMD) -C lib/arprefresh DESTDIR=$(DESTDIR) install

watchdog:
		$(MAKECMD) -C lib/watchdog clean
		$(MAKECMD) -C lib/watchdog
		$(MAKECMD) -C lib/watchdog DESTDIR=$(DESTDIR) install

build_all:	all switch libs
install_all:	install install_libs
clean_all:	uberclean clean_libs

=== lib/bmf/Makefile ===
#
# OLSR Basic Multicast Forwarding (BMF) plugin.
# Copyright (c) 2005, 2006, Thales Communications, Huizen, The Netherlands.
# Written by Erik Tromp.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# * Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright 
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
# * Neither the name of Thales, BMF nor the names of its 
#   contributors may be used to endorse or promote products derived 
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_bmf
PLUGIN_VER =	1.7.0

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

#LIBS +=	$(OS_LIB_PTHREAD)

ifeq ($(OS),$(filter $(OS),linux android))

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
		$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

else

default_target install clean: 
	@echo "*** BMF Plugin only supported on Linux and Android, sorry!"

endif

=== lib/httpinfo/Makefile ===
# The olsr.org Optimized Link-State Routing daemon(olsrd)
# Copyright (c) 2004, Andreas Tonnesen(andreto@olsr.org)
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# * Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright 
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its 
#   contributors may be used to endorse or promote products derived 
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_httpinfo
PLUGIN_VER =	0.1

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

ifdef ADMIN_INTERFACE
CPPFLAGS +=	-DADMIN_INTERFACE
endif

OBJS += $(TOPDIR)/src/cfgparser/cfgfile_gen.o

default_target: $(PLUGIN_FULLNAME)
ifdef ADMIN_INTERFACE
		@echo 'WARNING - BUILT WITH EXPERIMENTAL ADMIN INTERFACE!'
endif

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
		$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

=== lib/nameservice/Makefile ===
# The olsr.org Optimized Link-State Routing daemon(olsrd)
# Copyright (c) 2004, Andreas Tonnesen(andreto@olsr.org)
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# * Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright 
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its 
#   contributors may be used to endorse or promote products derived 
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_nameservice
PLUGIN_VER =	0.3

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

ifeq ($(OS),win32)
default_target install clean:
	@echo "**** We use the regex library here. Does Win32 has something like this?"
else
ifeq ($(OS),android)
# On Android Google forgot to include regex engine code for Froyo version (but also there was
# no support in older versions for it) so we have here this missing code.
# http://groups.google.com/group/android-ndk/browse_thread/thread/5ea6f0650f0e3fc
SRCS +=     $(wildcard $(TOPDIR)/android/regex/reg*.c)
HDRS +=     $(wildcard $(TOPDIR)/android/regex/*.h)
CFLAGS += -D__POSIX_VISIBLE
endif

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
		$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)
endif

=== lib/p2pd/Makefile ===

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_p2pd
PLUGIN_VER =	0.1.0

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

LIBS +=	$(OS_LIB_PTHREAD)

# Must be specified along with -lpthread on linux
CPPFLAGS += $(OS_CFLAG_PTHREAD)

ifneq ($(OS),linux)

default_target install clean:
	@echo "*** p2pd Plugin only supported on Linux, sorry!"

else

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
		$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

endif

=== lib/quagga/Makefile ===
# The olsr.org Optimized Link-State Routing daemon(olsrd)
# Copyright (c) 2004, Andreas Tonnesen(andreto@olsr.org)
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# * Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright 
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its 
#   contributors may be used to endorse or promote products derived 
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_quagga
PLUGIN_VER =	0.2.2

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

CFLAGS += -g

#uncomment the following line only if you are sure what you're doing, it will 
#probably break things! 
# CPPFLAGS +=-DZEBRA_HEADER_MARKER=255 

ifeq ($(OS),win32)
default_target install clean:
	@echo "*** Quagga not supported on Windows (so it would be pointless to build the Quagga plugin)"
else
default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
		$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)
endif

=== lib/watchdog/Makefile ===
# The olsr.org Optimized Link-State Routing daemon(olsrd)
# Copyright (c) 2004-2009, the olsr.org team - see HISTORY file
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_watchdog
PLUGIN_VER =	0.1

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
		$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

=== debian/changelog ===
olsrd (0.6.1-4) unstable; urgency=low

  * Added debian/watch

 -- Roland Stigge <stigge@antcom.de>  Mon, 01 Aug 2011 21:54:18 +0200

olsrd (0.6.1-3) unstable; urgency=low

  * Added armv7l to arch list for -fPIC in make/Makefile.linux
    (Closes: #636205)

 -- Roland Stigge <stigge@antcom.de>  Mon, 01 Aug 2011 21:23:31 +0200

olsrd (0.6.1-2) unstable; urgency=low

  * Add patch to upstream to add mips and mips64 to -fPIC arch list
    (fixes FTBFS on mips*)

 -- Roland Stigge <stigge@antcom.de>  Sat, 07 May 2011 13:11:27 +0200

olsrd (0.6.1-1) unstable; urgency=low

  [ Holger Levsen ]
  * New upstream version with quite some fixes and new features, see upstream
    changelog for details. Quoting from there:
     Change in version number system. No more -rcX for release candidates and
     -rX for bugfix releases. In future bugfix releases or updates of plugins
     will increase the third digit of the version string while feature 
     releases will increase the first and/or the second one.
  * Update package description, OLSR is no experimental protocol anymore.

  [ Roland Stigge ]
  * New maintainer (Closes: #612277)
  * Adjusted debian patches to work with 0.6.1
  * debian/control:
    - Standards-Version: 3.9.2
    - Build-Depends: debhelper (>=8)
  * Debian source format: 3.0 (quilt)
  * Included remaining plugins
  * New upstream version works with newer kernels (Closes: #605296)
  * New upstream version fixes memory leak (Closes: #605295)

 -- Roland Stigge <stigge@antcom.de>  Tue, 03 May 2011 15:30:56 +0200

olsrd (0.5.6-r8-1) unstable; urgency=low

  * New upstream version, the eighth maintenance release of 0.5.6, introducing
    options to set the source and destination IP of the OLSR packets and a 
    more flexible handling config handling as well as some bug fixes including
    memory leaks.

 -- Holger Levsen <holger@debian.org>  Wed, 20 Jan 2010 01:13:43 +0000

olsrd (0.5.6-r7-1) unstable; urgency=low

  * New upstream version, the seventh maintenance release of 0.5.6, with some
    improvements in the ETX-FFmetric and new stabilization patches for the 
    route generation.

 -- Holger Levsen <holger@debian.org>  Wed, 11 Nov 2009 17:53:26 +0100

olsrd (0.5.6-r6-3) unstable; urgency=low

  * Brown paper bag release: add 270-make-kfbsd.patch to debian/patches/series
    so it actually gets applied. (Closes: #544758)

 -- Holger Levsen <holger@debian.org>  Mon, 19 Oct 2009 11:31:38 +0200

olsrd (0.5.6-r6-2) unstable; urgency=low

  * Do not override the general setting in Makefile.kfbsd to "honor DESTDIR 
    in make install". Thanks to Petr Salinger for the patch. (Closes: #544758)

 -- Holger Levsen <holger@debian.org>  Sat, 17 Oct 2009 13:00:41 +0000

olsrd (0.5.6-r6-1) unstable; urgency=low

  * New upstream version, the sixth maintenance release of 0.5.6, adding
    support for Debian kfreebsd (Closes: #544758) and including fixes for
    httpinfo, txtinfo and dotdraw plugin to prevent them blocking in case of
    timed out outgoing connections. 
    Drop 250-dot-draw-plugin-honor-accept-parameter.patch as it has been
    included in the new upstream release.
  * Fix incorrect runlevels and dependencies in init.d LSB header, thanks to
    Petter Reinholdtsen for spotting the issues and providing the patch.
    (Closes: #548607)
  * Bump standards version to 3.8.3, no changes necessary.

 -- Holger Levsen <holger@debian.org>  Sat, 10 Oct 2009 14:55:37 +0200

olsrd (0.5.6-r5-1) unstable; urgency=low

  * New upstream version, the fifth maintenance release of 0.5.6.
  * Add patch by Sebastian Harl to add a listen parameter to the dot_draw
    plugin. (Closes: #532573) - Thanks, Sebastian! 
  * Re-enable quagga plugin. Since olsrd is licenced under the 3 clause BSD 
    licence and quagga is GPL-2 code, the resuling binary is GPL-2 licenced
    too, and thats fine. (Closes: #532761)
    Add patch by Florian Forster to determine quagga protocol version - thanks
    Florian!
  * Add descriptions of quagga, bmf and txtinfo plugins to package 
    description. (Closes: #532765)
  * Bump standards version to 3.8.2.
  * Update years in debian/copyright.

 -- Holger Levsen <holger@debian.org>  Tue, 04 Aug 2009 12:10:35 +0000

olsrd (0.5.6-r4-1) unstable; urgency=low

  * New upstream version, the fourth maintenance release of 0.5.6.
  * olsrd.init: 
    - do not write the pidfile until olsrd has actually been started
      (Closes: #519842) - thanks to Sebastian Reichel for the bug report!
    - only start olsrd if it is not already running. 
  * Bump standards-version to 3.8.1.

 -- Holger Levsen <holger@debian.org>  Sat, 30 May 2009 09:14:27 +0000

olsrd (0.5.6-r3-1) unstable; urgency=low

  * New upstream release, the third maintenance release of 0.5.6.
  * Adopt debian/patches/200-etc-olsrd.patch to cope with the whitespace
    changes in the new release.

 -- Holger Levsen <holger@debian.org>  Sat, 14 Mar 2009 18:31:55 +0100

olsrd (0.5.6~rc7-1) unstable; urgency=low

  * New upstream release candidate.
  * Use a PID file. (Closes: #484128)
  * Bump standards-version to 3.8.0, no changes needed.
  * Install the plugins into /usr/lib/olsrd/, to get rid off all the lintian
    overrides. Adapted README.Debian to reflect that.
  * Compile the source without DESTDIR, just install it to DESTDIR.
  * Modify the plugin targets in the upstream Makefile to provide distinct
    $pluginname_install targets, otherwise DESTDIR shows up in rpath. 
  * Drop debian/patches/210-txtinfo-Makefile.patch as it has been adapted by
    upstream.

 -- Holger Levsen <holger@debian.org>  Sat, 12 Jul 2008 16:38:15 +0000

olsrd (0.5.5-3) unstable; urgency=low

  * No longer work around a bug in debhelper (#470913) in debian/rules,
    which was introduced in 0.5.5-2 to fix #471627. Due to this, it's also not
    necessary to manually uncompress and compress some manpages, as debhelper
    now handles this as well.

 -- Holger Levsen <holger@debian.org>  Wed,  2 Apr 2008 13:06:27 +0200



=== debian/control ===
Source: olsrd
Section: net
Priority: extra
Maintainer: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 8), bison, flex
Standards-Version: 3.9.2
Homepage: http://olsr.org/
Vcs-Svn: svn://svn.debian.org/svn/collab-maint/deb-maint/olsrd/
Vcs-Browser: http://svn.debian.org/wsvn/collab-maint/deb-maint/olsrd/

Package: olsrd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: optimized link-state routing daemon (unik-olsrd)
 unik-olsrd is an implementation of the Optimized Link State Routing protocol 
 for Mobile Ad-Hoc networks(MANET). The protocol is described in RFC3626. It 
 is designed to be run as a standalone server process.
 .
 OLSR operates as a table driven, proactive protocol, i.e., it exchanges 
 topology information with other nodes of the network regularly. It is 
 developed to work independently from other protocols. Likewise, OLSR makes no
 assumptions about the underlying link-layer.

Package: olsrd-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, olsrd (= ${binary:Version})
Description: various plugins to enhance olsrd
 olsrd is an implementation of the Optimized Link State Routing protocol
 for Mobile Ad-Hoc networks(MANET)
 .
 The following plugins are available:
 .
  * httpinfo      - tiny webserver for information purposes 
  * dyn_gw        - dynamically announce uplinks
  * dot_draw      - generates output (over a TCP socket) in the dot format
  * secure        - secure OLSR routing with a shared key
  * nameservice   - announce hostnames and dns servers
  * bmf           - basic multicast forwarding
  * quagga        - import external routes from quagga
  * txtinfo       - display information about the OSLR node
 .
 The following plugins are also included, even though experimental and demo
 plugins:
 .
  * pgraph        - performance graph
  * watchdog      - detection of olsrd freeze
  * tas           - tiny application server
  * mini          - minimal example plugin (demo)
  * dyn_gw_plain  - dyn_gw without ping/libthread
  * arprefresh    - optimize kernel arp cache from olsr UDP sniffing
  * mdnsp         - multicast DNS via OLSR mesh network
  * p2pd          - distribute P2P Discovery messages

=== debian/rules ===
#!/usr/bin/make -f
# Holger Levsen, 2006-12, based on 
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	
	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
	$(MAKE) libs

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) uberclean
	rm -f $(CURDIR)/lib/*/src/*.o $(CURDIR)/lib/*/*.so.?.?

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep 
	dh_installdirs

	# Add here commands to install the package into debian/olsrd.
	$(MAKE) DESTDIR=$(CURDIR)/debian/olsrd install STRIP=: 
	$(MAKE) DESTDIR=$(CURDIR)/debian/olsrd-plugins libs_install STRIP=:

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -polsrd CHANGELOG -polsrd-plugins
	# rename to fit the naming scheme of the other plugin READMEs
	cp $(CURDIR)/lib/bmf/README_BMF.txt $(CURDIR)/lib/bmf/README_BMF
	dh_installdocs
	dh_installinit
	dh_installman
	dh_link
	dh_strip
	# compress, but don't compress README_NAMESERVICE, for consistency reasons
	dh_compress -XREADME_NAMESERVICE -XREADME_BMF
	# provide better default config
	rm $(CURDIR)/debian/olsrd/etc/olsrd.conf
	cp $(CURDIR)/debian/olsrd.conf $(CURDIR)/debian/olsrd/etc/olsrd/olsrd.conf
	cp  $(CURDIR)/debian/olsrd-default $(CURDIR)/debian/olsrd/etc/default/olsrd
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
